.\" @(#)mpeg2ppm 1.2 15/01/94;
.TH MPEG2PPM 1.2 "15 January 1995"
.SH NAME
mpeg2ppm \- MPEG to PPM converter
.SH SYNOPSIS
.B mpeg2ppm [-h] [-f] [-s start] [-e end] [filename]
.SH DESCRIPTION
.I Mpeg2ppm
will decode a (video\-only) MPEG\-I\-stream and extract the rebuild
frames as PPM\-files (Portable Pixmap). The extracted frames will be
numbered starting from zero (0), the first part of the filename is
derived from the original MPEG\-stream, the files extension will be \.PPM.
.PP
The final PPM\-files will be in 24\-bit\-format.
.PP
.TP 12
.B -h
This option will show the usage.
.PP
.TP 12
.B -f
This option will extract only the first frame of the MPEG\-stream.
The PPM\-file will be named after the MPEG\-stream\-file, its
extension will be \.PPM.
.PP
.TP 12
.B -s start
This option let you specify a starting frame. Converting
will start with the specified framenumber. Has to be
used in conjunction with the following option.
.PP
.TP 12
.B -e end
This option let you specify the ending frame. Converting
will stop with the specified framenumber. Has to be
used in conjunction with the option above.
.SH EXAMPLES
You could start
.I mpeg2ppm
with f.e. the following options:
.PP
mpeg2ppm -h
.br
mpeg2ppm -f < ifa.mpg
.br
mpeg2ppm -s 10 -e 20 ifa.mpg
.SH NOTES
.I Mpeg2ppm
expects MPEG-1 video streams only. It can not handle
multiplexed MPEG streams or video+audio streams. The converter uses
the paris entropy coding table set (which I believe to be the MPEG-1
standard).
.LP
Some streams do not end with the proper sequence end code and will
probably generate an "Improper sequence end code." error when done playing.
.SH THANKS
Special thanks to the Berkeley\-code "mpeg_play" and the PPM\-patch by
.PP
.TP 16
.B Ketan Patel
University of California, Berkeley, kpatel@cs.berkeley.edu
.TP 16
.B Brian Smith
University of California, Berkeley, bsmith@cs.berkeley.edu
.TP 16
.B Henry Chi-To Ma
University of California, Berkeley, cma@cs.berkeley.edu
.TP 16
.B Kim Man Liu
University of California, Berkeley, kliu@cs.berkeley.edu
.TP 16
.B Jef Poskanzer
jef@netcom.com
.SH COPYRIGHT
.I Mpeg2ppm
was developed by
.PP
.I PHADE Software
.br
Inh. Frank Gadegast
.br
Leibnizstr. 30
.br
10625 Berlin GERMANY
.PP
.B phade@contrib.de, http://www.contrib.de/~phade
